<%@ Page Title="" Language="C#" MasterPageFile="~/Registry.master" AutoEventWireup="true" CodeFile="Referral_old.aspx.cs" Inherits="TBI_Referrals" %>

<%@ Register Assembly="AjaxControlToolkit" Namespace="AjaxControlToolkit" TagPrefix="cc1" %>

<asp:Content ID="Content1" ContentPlaceHolderID="head" Runat="Server">
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder" Runat="Server">
    <p>
        Add / Edit TBI Screening</p>
    <p>
        <asp:HyperLink ID="HyperLinkDefinitions" runat="server" Target="_blank" NavigateUrl="~/documents/TBIAPPLICATIONFIELDDEFINITIONS.doc">Click here to view Data Definitions for each of the fields</asp:HyperLink>
    </p>
    <p>
        <asp:FormView ID="FormViewReferral" runat="server" DefaultMode="Edit"
            DataSourceID="ObjectDataSourceReferral" DataKeyNames="REFERRAL_ID,ROW_VERSION">
            <EditItemTemplate>
                <table summary="for layout purposes" cellpadding="3" cellspacing="3" border="0" width="100%">
                    <tr>
                        <td>
                        Facility:
                        </td>
                        <td style="width:10px">
                            &nbsp;</td>
                        <td>
                            (<asp:Label ID="LabelVamcVisn" runat="server" Text='<%# Eval("STD_INSTITUTION.STD_INSTITUTION_PARENT.NAME")%>'></asp:Label>)
                            (<asp:Label ID="LabelVamcStationNumber" runat="server" Text='<%# Eval("STD_INSTITUTION.STATIONNUMBER")%>'></asp:Label>)
                            <asp:Label ID="LabelVamcVistaName" runat="server" Text='<%# Eval("STD_INSTITUTION.VISTANAME")%>'></asp:Label>
                        </td>
                    </tr>
                    <tr>
                        <td>
                        Name/SS# of Patient with + screen and desiring eval
                        </td>
                        <td>
                            &nbsp;</td>
                        <td>
                            <asp:Label ID="LabelPatientLastName" runat="server" Text='<%# Eval("PATIENT.LAST_NAME") %>'></asp:Label>,&nbsp;
                            <asp:Label ID="LabelPatientFirstName" runat="server" Text='<%# Eval("PATIENT.FIRST_NAME") %>'></asp:Label>
                            <asp:Label ID="LabelPatientMiddleName" runat="server" Text='<%# Eval("PATIENT.MIDDLE_NAME") %>'></asp:Label>
                            &nbsp;-&nbsp;
                            <asp:Label ID="LabelPatientSSN" runat="server" Text='<%# Eval("PATIENT.SSN") %>'></asp:Label>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            Date of Screening
                        </td>
                        <td>
                            &nbsp;</td>
                        <td>                            
                            <asp:TextBox ID="TextBoxReferralDate" runat="server" ReadOnly="true" Enabled="false"
                            Text='<%# Bind("REFERRAL_DATE","{0:MM/dd/yyyy}")%>' />
                        </td>
                    </tr>
                    <tr>
                        <td>
                        Date of Consult/Referral
                        </td>
                        <td>
                            &nbsp;</td>
                        <td>
                            <asp:FormView ID="FormViewWKFCasesDateConsult" CellPadding="0" CellSpacing="0" runat="server" AllowPaging="false" DefaultMode="Edit"
                                    DataSource="<%# ((VeteransAffairs.Registries.Business.REFERRAL)Container.DataItem).PATIENT%>" DataKeyNames="PATIENT_ID,ROW_VERSION">
                                <EditItemTemplate>
                                    <asp:TextBox ID="TextBoxDateConsultReferral" runat="server" 
                                    Text='<%# Bind("TBI_TRACKING.REFERRAL_SCHEDULE_DATE","{0:MM/dd/yyyy}")%>' />
                                    <br />
                                    <asp:CheckBox ID="CheckBoxNotApplicable" runat="server"  
                                        Checked='<%# Bind("TBI_TRACKING.CONSULT_NOT_APPLICABLE_FLAG")%>' AutoPostBack="True" 
                                        oncheckedchanged="CheckBoxNotApplicable_CheckedChanged" /> Not Applicable
                                    <cc1:CalendarExtender ID="CalendarExtenderDateConsultReferral" runat="server"
                                      TargetControlID="TextBoxDateConsultReferral" 
                                      PopupButtonID="TextBoxDateConsultReferral"></cc1:CalendarExtender>
                                </EditItemTemplate>
                            </asp:FormView>
                        </td>
                    </tr>
                    <tr>
                        <td>
                        Other Consult Referral Status
                        </td>
                        <td>
                            &nbsp;</td>
                        <td>
                            <asp:FormView ID="FormViewWKFCasesOtherConsultStatus" CellPadding="0" CellSpacing="0" runat="server" AllowPaging="false" DefaultMode="Edit" 
                                    DataSource="<%# ((VeteransAffairs.Registries.Business.REFERRAL)Container.DataItem).PATIENT%>" DataKeyNames="PATIENT_ID,ROW_VERSION">
                                <EditItemTemplate>
                                    <asp:DropDownList ID="DropDownListOtherConsultStatus" runat="server" AutoPostBack="True" 
                                        DataSourceID="ObjectDataSourceOtherConsultStatus" DataTextField="NAME" 
                                        DataValueField="ID" SelectedValue='<%# Bind("TBI_TRACKING.STD_TBIREFERRALSTS_ID") %>'
                                        Enabled='<%# Eval("TBI_TRACKING.TbiConsultStatusIsEditable") %>'
                                        AppendDataBoundItems="true" 
                                        onselectedindexchanged="DropDownListOtherConsultStatus_SelectedIndexChanged">
                                        <asp:ListItem Value="">-- Select a Value --</asp:ListItem>
                                    </asp:DropDownList>
                                    
                                    <asp:ObjectDataSource ID="ObjectDataSourceOtherConsultStatus" runat="server" 
                                        SelectMethod="GetTBIOtherConsultStatusList" 
                                        TypeName="VeteransAffairs.Registries.BusinessManager.Utilities.DropDownLists">
                                    </asp:ObjectDataSource>
                                </EditItemTemplate>
                            </asp:FormView>
                        </td>
                    </tr>
                    <asp:Literal ID="LiteralConsultNotSubmittedNotice" Visible="false" runat="server">
                        <tr>
                            <td colspan="3">
                                <div style="color:Red">
                                Consult not submitted - Further evaluation is required for this patient.  Please arrange for comprehensive TBI evaluation for this patient and update this patient entry in the TBI Screening and Evaluation Tracking Application once those arrangements have been made.  The status of this case cannot move to "completed" until this field has been changed to reflect the follow up status for this patient.
                                </div>
                            </td>
                        </tr>
                    </asp:Literal>              
                    <tr>
                        <td>
                        Attempts to Contact Patient for Scheduling Purposes
                        </td>
                        <td>
                            &nbsp;</td>
                        <td>
                            <asp:ListView ID="ListViewAttempts" runat="server" DataSource="<%# ((VeteransAffairs.Registries.Business.REFERRAL)Container.DataItem).WKF_CASEs[0].WKF_CASE_ACTIVITies%>">
                               <LayoutTemplate>
                                    <asp:PlaceHolder runat="server" ID="itemPlaceholder"></asp:PlaceHolder>
                               </LayoutTemplate>
                               <ItemTemplate>
                                    <asp:DropDownList ID="DropDownListAttempts" runat="server" AutoPostBack="False" 
                                        DataSourceID="ObjectDataSourceAttemptsStatus" DataTextField="NAME" 
                                        DataValueField="ID" SelectedValue='<%# Bind("STD_TBISCHEDULESTATUS_ID") %>'
                                        
                                        
                                        AppendDataBoundItems="true">
                                        <asp:ListItem Value="">-- Select a Value --</asp:ListItem>
                                    </asp:DropDownList>
                               </ItemTemplate>
                            </asp:ListView>
                            <asp:ObjectDataSource ID="ObjectDataSourceAttemptsStatus" runat="server" 
                                SelectMethod="GetTBISheduleStatusList" 
                                TypeName="VeteransAffairs.Registries.BusinessManager.Utilities.DropDownLists">
                            </asp:ObjectDataSource>
                        </td>
                    </tr>
                    <tr>
                        <td>
                        </td>
                        <td>
                            &nbsp;</td>
                        <td>
                        </td>
                    </tr>
                    <tr>
                        <td>
                        </td>
                        <td>
                            &nbsp;</td>
                        <td>
                        </td>
                    </tr>
                    <tr>
                        <td>
                        </td>
                        <td>
                            &nbsp;</td>
                        <td>
                        </td>
                    </tr>
                    <tr>
                        <td>
                        </td>
                        <td>
                            &nbsp;</td>
                        <td>
                        </td>
                    </tr>
                    <tr>
                        <td>
                            Status
                        </td>
                        <td>
                            &nbsp;</td>
                        <td>
                            <asp:DropDownList ID="DropDownListReferralStatus" runat="server" AutoPostBack="False" 
                                        DataSourceID="ObjectDataSourceReferralStatus" DataTextField="NAME" 
                                        DataValueField="ID" SelectedValue='<%# Bind("STD_REFERRALST_ID") %>'
                                        Enabled='<%# Eval("TbiReferralStatusIsEditable") %>'
                                        onselectedindexchanged="DropDownListReferralStatus_SelectedIndexChanged">
                            </asp:DropDownList>
                            <asp:ObjectDataSource ID="ObjectDataSourceReferralStatus" runat="server" 
                                SelectMethod="GetTBIReferralStatusList" 
                                TypeName="VeteransAffairs.Registries.BusinessManager.Utilities.DropDownLists">
                            </asp:ObjectDataSource>
                        </td>
                    </tr>
                                 
                </table>
                REFERRAL_ID:
                <asp:TextBox ID="REFERRAL_IDTextBox" runat="server" 
                    Text='<%# Bind("REFERRAL_ID") %>' />
                <br />
                
                STD_REGISTRY_ID:
                <asp:TextBox ID="STD_REGISTRY_IDTextBox" runat="server" 
                    Text='<%# Bind("STD_REGISTRY_ID") %>' />
                <br />
                PATIENT_ID:
                <asp:TextBox ID="PATIENT_IDTextBox" runat="server" 
                    Text='<%# Bind("PATIENT_ID") %>' />
                <br />
                STD_INSTITUTION_ID:
                <asp:TextBox ID="STD_INSTITUTION_IDTextBox" runat="server" 
                    Text='<%# Bind("STD_INSTITUTION_ID") %>' />
                <br />
                
                REFERRAL_CLASS_TXT:
                <asp:TextBox ID="REFERRAL_CLASS_TXTTextBox" runat="server" 
                    Text='<%# Bind("REFERRAL_CLASS_TXT") %>' />
                <br />
                PROVIDER_ID_NUMBER:
                <asp:TextBox ID="PROVIDER_ID_NUMBERTextBox" runat="server" 
                    Text='<%# Bind("PROVIDER_ID_NUMBER") %>' />
                <br />
                PROVIDER_NAME:
                <asp:TextBox ID="PROVIDER_NAMETextBox" runat="server" 
                    Text='<%# Bind("PROVIDER_NAME") %>' />
                <br />
                PROVIDER_PHONE:
                <asp:TextBox ID="PROVIDER_PHONETextBox" runat="server" 
                    Text='<%# Bind("PROVIDER_PHONE") %>' />
                <br />
                PROVIDER_EMAIL:
                <asp:TextBox ID="PROVIDER_EMAILTextBox" runat="server" 
                    Text='<%# Bind("PROVIDER_EMAIL") %>' />
                <br />
                CREATED_BY:
                <asp:TextBox ID="CREATED_BYTextBox" runat="server" 
                    Text='<%# Bind("CREATED_BY") %>' />
                <br />
                CREATED_DATE:
                <asp:TextBox ID="CREATED_DATETextBox" runat="server" 
                    Text='<%# Bind("CREATED_DATE") %>' />
                <br />
                UPDATED_BY:
                <asp:TextBox ID="UPDATED_BYTextBox" runat="server" 
                    Text='<%# Bind("UPDATED_BY") %>' />
                <br />
                UPDATED_DATE:
                <asp:TextBox ID="UPDATED_DATETextBox" runat="server" 
                    Text='<%# Bind("UPDATED_DATE") %>' />
                <br />
                
                <br />
                
                
                <asp:LinkButton ID="UpdateButton" runat="server" CausesValidation="True" 
                    CommandName="Update" Text="Update" />
                &nbsp;<asp:LinkButton ID="UpdateCancelButton" runat="server" 
                    CausesValidation="False" CommandName="Cancel" Text="Cancel" />
            </EditItemTemplate>
        </asp:FormView>
        <asp:ObjectDataSource ID="ObjectDataSourceReferral" runat="server" 
            OldValuesParameterFormatString="original_{0}" 
            ConflictDetection="CompareAllValues" 
            SelectMethod="SelectByID" 
            TypeName="VeteransAffairs.Registries.BusinessManager.TBI.TBIReferralManager"
            DataObjectTypeName="VeteransAffairs.Registries.Business.REFERRAL"
            UpdateMethod="Update" onselected="ObjectDataSourceReferral_Selected" 
            onupdating="ObjectDataSourceReferral_Updating">
            <SelectParameters>
                <asp:QueryStringParameter Name="id" QueryStringField="id" Type="Int32" />
            </SelectParameters>
        </asp:ObjectDataSource>
    </p>
    <p>
        
    </p>
    
</asp:Content>

